const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const production_operations = sequelize.define(
    'production_operations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

operation_number: {
        type: DataTypes.INTEGER,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"queued",


"running",


"paused",


"completed",


"skipped"

        ],

      },

planned_start: {
        type: DataTypes.DATE,
      
      

      },

planned_end: {
        type: DataTypes.DATE,
      
      

      },

actual_start: {
        type: DataTypes.DATE,
      
      

      },

actual_end: {
        type: DataTypes.DATE,
      
      

      },

good_qty: {
        type: DataTypes.DECIMAL,
      
      

      },

scrap_qty: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  production_operations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity



































    db.production_operations.hasMany(db.downtime_events, {
      as: 'downtime_events_production_operation',
      foreignKey: {
          name: 'production_operationId',
      },
      constraints: false,
    });








//end loop



    db.production_operations.belongsTo(db.production_orders, {
      as: 'production_order',
      foreignKey: {
        name: 'production_orderId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.routing_steps, {
      as: 'routing_step',
      foreignKey: {
        name: 'routing_stepId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.work_centers, {
      as: 'work_center',
      foreignKey: {
        name: 'work_centerId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.machines, {
      as: 'machine',
      foreignKey: {
        name: 'machineId',
      },
      constraints: false,
    });

    db.production_operations.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.production_operations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.production_operations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return production_operations;
};


